import { LechaptCalmon, Observer } from "jalhyd";
import { SelectField } from "../../select-field";
import { FormulaireBase } from "./form-base";
import { NgParamInputComponent } from "../../../components/ngparam-input/ngparam-input.component";

export class FormulaireLechaptCalmon extends FormulaireBase implements Observer {

    protected completeParse(json: {}) {
        super.completeParse(json);
        // abonnement au changement de valeur du select de matériau
        this.getFormulaireNodeById("select_material").addObserver(this);
        // abonnement au changement de valeur de l'un des trois champs affectés par le changement de matériau
        this.getParamFromSymbol("L").addObserver(this);
        this.getParamFromSymbol("M").addObserver(this);
        this.getParamFromSymbol("N").addObserver(this);
    }

    // interface Observer

    public update(sender: any, data: any) {

        super.update(sender, data);

        // en cas de changement de valeur du select de matériau, effacement des résultats et MAJ des champs L,M,N
        if (sender instanceof SelectField) {
            if (data.action === "select") {
                if (data.value._value !== "") {
                    (this.currentNub as LechaptCalmon).applyMaterialPreset(data.value._value);
                }
                // update GUI
                this.getParamFromSymbol("L").notifyValueModified(this);
                this.getParamFromSymbol("M").notifyValueModified(this);
                this.getParamFromSymbol("N").notifyValueModified(this);
                this.reset();

            }
        }
        if (sender instanceof NgParamInputComponent) {
            if (data.action === "ngparamAfterValue") {
                // value of L, M or N changed
                const materialSelect = this.getFormulaireNodeById("select_material") as SelectField;
                // reset material select field to "" (empty)
                materialSelect.setValue(materialSelect.entries[0]);
            }
        }
    }
}
